import {
  app,
  BrowserWindow,
  dialog,
  crashReporter,
  nativeImage,
} from "electron";
import * as path from "path";
import installExtension, {
  REACT_DEVELOPER_TOOLS,
} from "electron-devtools-installer";

let window: BrowserWindow | null = null; // fem aixó perquè l'objecte window no l'elimini el GC

var image = nativeImage.createFromPath(
  path.join(__dirname + "./logo52x52a.png")
);
image.setTemplateImage(true);

function createWindow() {
  let { width, height } = { width: 900, height: 680 };

  window = new BrowserWindow({
    width: width,
    height: height,
    frame: false,
    icon: image, //path.join(__dirname + "./logo52x52a.png"),
    title: "Test",
    webPreferences: {
      // contextIsolation: false,

      nativeWindowOpen: true,
      nodeIntegration: false,
      nodeIntegrationInWorker: false,
      nodeIntegrationInSubFrames: false,
      contextIsolation: true,
      preload: path.join(__dirname, "preload.js"),
    },
  });

  window.setMenu(null);

  if (app.isPackaged) {
    // 'build/index.html'
    window.loadURL(`file://${__dirname}/../index.html`);
  } else {
    window.loadURL("http://localhost:3000/index.html");

    window.webContents.openDevTools();

    // Hot Reloading on 'node_modules/.bin/electronPath'
    require("electron-reload")(__dirname, {
      electron: path.join(
        __dirname,
        "..",
        "..",
        "node_modules",
        ".bin",
        "electron" + (process.platform === "win32" ? ".cmd" : "")
      ),
      forceHardReset: true,
      hardResetMethod: "exit",
    });
  }

  window.on("closed", () => (window = null));

  window.webContents.on("render-process-gone", function (event, detailed) {
    if (detailed.reason === "crashed") {
    }
  });

  // Configurem log
}

process.on("uncaughtException", function (error) {
  // Handle the error
});

console.log(app.getPath("crashDumps"));
crashReporter.start({ submitURL: "", uploadToServer: false });

app.whenReady().then(() => {
  // DevTools
  installExtension(REACT_DEVELOPER_TOOLS)
    .then((name) => console.log(`Added Extension:  ${name}`))
    .catch((err) => console.log("An error occurred: ", err));

  createWindow();

  app.on("activate", () => {
    if (BrowserWindow.getAllWindows().length === 0) {
      createWindow();
    }
  });

  app.on("window-all-closed", () => {
    if (process.platform !== "darwin") {
      app.quit();
    }
  });
});
