import React, { useState, useEffect } from "react";

import "./App.scss";
import ReportPage from "./pages/ReportPage";

declare global {
  interface Window {
    electron: any;
    log: any;
  }
}

function App() {
  window.onerror = (msg, url, line, col, error) => {
    // Note that col & error are new to the HTML 5 spec and may not be
    // supported in every browser.  It worked for me in Chrome.
    var extra = !col ? "" : "\ncolumn: " + col;
    extra += !error ? "" : "\nerror: " + error;

    // You can view the information in an alert to see things working like this:
    window.log.error(
      "Error: " + msg + "\nurl: " + url + "\nline: " + line + extra
    );

    var suppressErrorAlert = true;
    return suppressErrorAlert;
  };

  window.onunhandledrejection = (e: PromiseRejectionEvent) => {
    console.error(e);
    window.log.error(e.reason.stack);
    // throw new Error(e.reason.stack);
  };

  return (
    <div>
      <ReportPage />
    </div>
  );
}

export default App;
