import React, { useEffect } from "react";

import { StiOptions,Stimulsoft } from "stimulsoft-reports-js/Scripts/stimulsoft.designer";
import useStateRef from "../../pages/useStateRef";
interface IPropsReportViewer {
  report: string;
}

interface IPropsReportDesigner {
  report?: string;
}

export function ReportViewer(props: IPropsReportViewer) {
  //let Stimulsoft: any;
  //const win: any = window;
  const [viewer, setViewer, viewerRef] = useStateRef<any>(null);

  useEffect(() => {
    //Stimulsoft = win.Stimulsoft;

    var report = Stimulsoft.Report.StiReport.createNewReport();
    // report.loadFile("Report.mrt");
    report.load(report);
    console.log("Report: ", report);
    var options = new Stimulsoft.Viewer.StiViewerOptions();
    setViewer(new Stimulsoft.Viewer.StiViewer(options, "StiViewer", false));
    viewerRef.current.report = report;

    setupViewer();
  }, []);

  const setupViewer = () => {
    var report = Stimulsoft.Report.StiReport.createNewReport();
    report.load(props.report);

    viewerRef.current.report = report;
    viewerRef.current.renderHtml("viewerContent");
  };

  return (
    <div>
      <div id="viewerContent"></div>
    </div>
  );
}

export function ReportDesigner(props: IPropsReportDesigner) {
  //let Stimulsoft: any;
  //const win: any = window;

  const [designer, setDesigner, designerRef] = useStateRef<any>(null);

  useEffect(() => {
    //Stimulsoft = win.Stimulsoft;
    console.log("Designer componentWillMount: ", Stimulsoft);

    StiOptions.WebServer.encryptData = false;
    StiOptions.WebServer.url = "https://localhost:44366/DataAdapters";
    
    //StiOptions.WebServer.url = "https://192.168.0.144:44366/DataAdapters";

    var report = Stimulsoft.Report.StiReport.createNewReport();

    var options = new Stimulsoft.Designer.StiDesignerOptions();
    options.appearance.fullScreenMode = true;
    setDesigner(
      new Stimulsoft.Designer.StiDesigner(options, "StiDesigner", false)
    );

    designerRef.current.report = report;

    designerRef.current.renderHtml("designerContent");
  }, []);

  return <div id="designerContent"></div>;
}
