import React, { useState, useRef, useCallback } from "react";

export default function useStateRef<T>(
  defaultValue: any
): [T, (val: any) => void, React.MutableRefObject<T>] {
  var [state, setState] = useState<T>(defaultValue);
  var ref = useRef(state);

  var dispatch = useCallback(function (val:any) {
    ref.current = typeof val === "function" ? val(ref.current) : val;

    setState(ref.current);
  }, []);

  return [state, dispatch, ref];
}
